{-----------------------------------------------------------------------------}
{        General Declarations                                                 }
{-----------------------------------------------------------------------------}
Type TPString   = String[32];
     OpenString = String[12];
     
{Command array for the Vdp access }

Var _sx  :Integer Absolute $f562 ;
    _sy  :Integer Absolute $f564 ;
    
    { haaaaack! }
    _sy1 :byte Absolute $f564;
    _sx1 :byte Absolute $f562;
    
    _dx  :Integer Absolute $f566 ;
    _dy  :Integer Absolute $f568 ;
    _nx  :Integer Absolute $f56a ;
    _ny  :Integer Absolute $f56c ;
    _col :Byte Absolute    $f56e ;
    _arg :Byte Absolute    $f56f ;
    _cmd :Byte Absolute    $f570 ;

Var Jiffy: integer absolute $FC9E; 
    ClickSW: integer absolute $F3DB;

{Vdp Copy commands }

Const HMMC = $F0 ; {High speed Byte Cpu  -> Vram }
      YMMM = $E0 ; {High speed Byte Vram -> Vram in y-axis }
      HMMM = $D0 ; {High speed Byte Vram -> Vram in x- and y-axis }
      HMMV = $C0 ; {High speed Byte Vdp  -> Vram = paint a box }

      LMMC = $B0 ; {Logical Dot     Cpu  -> Vram }
      LMCM = $A0 ; {Logical Dot     Vram -> Cpu  }
      LMMM = $90 ; {Logical Dot     Vram -> Vram }
      LMMV = $80 ; {Logical Dot     Vdp  -> Vram = paint a box }


{Copy directions for the ARG-register }

      Copy_Right = 0;
      Copy_Down  = 0;
      Copy_Left  = 4;
      Copy_Up    = 8;
      ExpansionVram   = 32 ;
      Vram  = 0 ;

Const TPSET=8;
Const Mult256:array[0..12] of integer=(0,256,512,768,1024,1280,1536,1792,2048,2304,2560,2816,3072);
Const Mult16:array[0..15] of byte=(0,16,32,48,64,80,96,112,128,144,160,176,192,208,224,240);

Procedure Screen(mode:Byte);
{ Igual ao screen do Basic }
Const EXPTBL = $fcc0;
      CALSLT = $001C;
      CHGMOD = $005F;

Begin
     Inline  (
              $f3                { di }
             /$3a/mode           { LD A,(MODE) }
             /$fd/$2a/$c0/$fc    { LD IY,(EXPTBL - 1 }
             /$DD/$21/$5f/00     { LD IX,CHGMOD }
             /$CD/$1c/00         { CALL CALSLT }
             /$fb                { EI }
             );

End;

Procedure Color(ForeGroundColor,BackGroudColor,BorderColor:Byte);
{ Igual ao color do Basic }

Var FORCLR :Byte Absolute $F3E9;
    BAKCLR :Byte Absolute $f3ea;
    BDRCLR :Byte Absolute $f3eb;

Begin
    FORCLR := ForeGroundColor;
    BAKCLR := BackGroudColor;
    BDRCLR := BorderColor;
    Inline (  $f3/
              $fd/$2a/$c0/$fc    { LD IY,(EXPTBL - 1 }
             /$DD/$21/$62/00     { LD IX,CHGCLR }
             /$CD/$1c/00/$fb     { CALL CALSLT }
           );
End;

Procedure SetPage(DisplayPage,ActivePage:Byte);
Const SETPAGE = $013D; {SubRom routine}

Var   DPPAGE :Byte Absolute  $FAF5;
      ACPAGE :Byte Absolute  $FAF6;

Begin
    DpPage := DispLayPage;
    AcPage := ActivePage;

    Inline (
             $f3
            /$fd/$2a/$f7/$fa    { LD IY,(EXbrsa - 1 }
            /$DD/$21/$3d/$01    { LD IX,setpage }
            /$CD/$1c/00         { CALL CALSLT }
            /$fb
             );
End;

Var
   VA:byte;
   VHL,VBC,VDE:integer;

Const
   GTSTCK=$D5;     {retorna o estado do joystick selecionado}
   GTTRIG=$D8;     {retorna o estado do botao de disparo selecionado}
   WRTPSG=$93;     {grava um byte num registro do PSG}

Procedure CallRom(VIX:integer);
BEGIN
inline($F3/$CD/*+19/$FB/$32/VA/$22/VHL/$ED/$43/VBC/$ED/$53/VDE/$18/$1B/
       $DD/$2A/VIX/$3A/VA/$2A/VHL/$ED/$4B/VBC/$ED/$5B/VDE/$08/$DB/$A8/
       $F5/$E6/$F0/$C3/$8C/$F3/$FB);
END;

Function Stick(n:byte):byte;
BEGIN
  VA:=n;
  CallRom(GTSTCK);
  Stick:=VA;
END;

Function Strig(n:byte):boolean;
BEGIN
   VA:=n;
   CallRom(GTTRIG);
   Strig:=(va<>0);
END;

Procedure Sound(r,v:byte);
BEGIN
   VA:=r;
   VDE:=v;
   CallRom(WRTPSG);
END;

Procedure _MoveDotToVram(SrcAddr:Integer;DestX,DestY:Integer;DestPage:Byte; Width,Height:Integer);
Var Address :Integer;

Begin

   Address:= SrcAddr+1; {Because the firstbyte is set in CMD array. }
   _cmd:= LMMC;
   _dy := Mult256[DestPage] + DestY;
   _arg:= 0;
   _dx := DestX;
   _nx := Width;
   _ny := Height;
   _col:= Mem[Address-1];
   Inline ($f3/$DD/$2A/Address/
          $3E/$02/$D3/$99/$3E/$8F/$D3/$99/$DB/$99/$CB/$47/
          $20/$F2/$F3/$3E/$20/$D3/$99/$3E/$11/$F6/$80/$D3/$99/$06/$0F/$0E/
          $9B/$21/$62/$F5/$ED/$B3/$3E/$2C/$F6/$80/$D3/$99/$3E/$11/$F6/$80/
          $D3/$99/$3E/$02/$D3/$99/$3E/$8F/$D3/$99/$DB/$99/$CB/$47/$28/$0D/
          $CB/$7F/$28/$EE/$DD/$7E/$00/$DD/$23/$D3/$9B/$18/$E5/$3E/$00/$D3/
          $99/$3E/$8F/$D3/$99/$DB/$99/$fb);
          
end ;

Procedure LoadGraphic(FileName :OpenString; Width, Height: Integer; x,y:Integer; Page:Byte);
Var ReadBuf    : array[0..511] of byte;
    Temp       : integer;   
    Counter,yy :Integer;
    
    Arq:file; 
    RecsRead: integer;

begin 
  Temp:=Addr(ReadBuf);
  {DotTemp:=Addr(DotBuf);}
  {Counter:=Width Div 2;}
  yy:=y;
  
  Assign(Arq,FileName);
  Reset(Arq);

  while yy<y+Height do begin
    BlockRead(Arq, ReadBuf, 2, RecsRead);
    _MoveDotToVram(Temp, 0, yy, Page, 256,1);
	{_WriteVram(Page, 32768+yy*256, Temp, 256);}
	yy:=yy+1;
  end;
  close(arq);
    
End;

Procedure cls2;
begin
  inline ($f3/$af/          { xor a         }
          $fd/$2a/$c0/$fc/  { ld iy,(#fcc0) }
          $dd/$21/$C3/$00/  { ld ix,#c3     }
          $cd/$1c/$00/$fb); { call #1c      }
end;   

{ _________________________________________________________ }


Procedure CopyY(SX,SY:Integer; SPg:Byte; Dy,Ny:Integer;DPg:Byte; Dir:Byte);
Begin
   _cmd:= YMMM ;
   _sy := Mult256[SPg]+ SY;
   _dy := Mult256[DPg] + Dy ;
   _arg:= Dir;
   _dx := Sx; {It`s not an error ! It's really like this.}
   _ny := Ny;
       Inline (   
       		  $F3/
              $3E/$20/  	{ LD A, 20h   } 
              $D3/$99/      { OUT (99h),A }
              $3E/$91/      { LD A, 11h   }
              $D3/$99/      { OUT (99h),A }
              $0E/$9B/      { LD C, 9Bh   }
              $21/$62/$F5/  { LD HL,F562h }

              $ED/$A3/      { 15x OUTI, faster }
              $ED/$A3/      { than OTIR        }
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/

              $3E/$02/      { LD A, 02h   }
              $D3/$99/      { OUT (99h),A }
              
              $3E/$8F/      { LD A, 8fh   }
              $00/          {             }
              
              $D3/$99/      { OUT (99h),A }
              $DB/$99/      { IN A,(99h)  }
              $CB/$47/      { BIT 0,A     }
              $20/$F0/      { JR NZ, F0h  }
              $AF/          { XOR A       }
              $D3/$99/      { OUT (99h),A }
              $3E/$8F/      { LD A, 0fh   }
              $D3/$99      { OUT (99h),A }
              /$FB
            );
End;


{ Copy FAST }
Procedure CopyF(X1,Y1,X2,Y2,SrcPage,DestX,DestY,DestPage:integer);
begin
   _cmd:= HMMM ;
   _sy := Mult256[SrcPage] + y1 ;
   _dy := Mult256[DestPage] + Desty ;
   _arg:= 0;
   _dx := Destx;
   _sx := x1;
   _nx := x2;
   _ny := y2;
       Inline (
         	  $F3/     
              $3E/$20/  	{ LD A, 20h   } 
              $D3/$99/      { OUT (99h),A }
              $3E/$91/      { LD A, 11h   }
              $D3/$99/      { OUT (99h),A }
              $0E/$9B/      { LD C, 9Bh   } 
              $21/$62/$F5/  { LD HL,F562h }

              $ED/$A3/      { 15x OUTI, faster }
              $ED/$A3/      { than OTIR        }
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/

              $3E/$02/      { LD A, 02h   }
              $D3/$99/      { OUT (99h),A }
              
              $3E/$8F/      { LD A, 8fh   }
              $00/          {             }
              
              $D3/$99/      { OUT (99h),A }
              $DB/$99/      { IN (99h),A  }
              $CB/$47/      { BIT 0,A     }
              $20/$F0/      { JR NZ, F0h  }
              $AF/          { XOR A       }
              $D3/$99/      { OUT (99h),A }
              $3E/$8F/      { LD A, 0fh   }
              $D3/$99      { OUT (99h),A }
			  /$FB              
            );
end;

{ Copy FAST Logical }
Procedure CopyFL(X1,Y1,X2,Y2,SrcPage,DestX,DestY,DestPage:integer);
begin
   _cmd:= $98; {LMMM + LogOp ;}
   _sy := Mult256[SrcPage]+y1 ;
   _dy := Mult256[DestPage]+Desty;
   _arg:= 0;
   _dx := Destx;
   _sx := x1;
   _nx := x2;
   _ny := y2;
       Inline (
         	  $F3/     
              $3E/$20/  	{ LD A, 20h   } 
              $D3/$99/      { OUT (99h),A }
              $3E/$91/      { LD A, 11h   }
              $D3/$99/      { OUT (99h),A }
              $0E/$9B/      { LD C, 9Bh   } 
              $21/$62/$F5/  { LD HL,F562h }

              $ED/$A3/      { 15x OUTI, faster }
              $ED/$A3/      { than OTIR        }
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/

              $3E/$02/      { LD A, 02h   }
              $D3/$99/      { OUT (99h),A }
              
              $3E/$8F/      { LD A, 8fh   }
              $00/          {             }
              
              $D3/$99/      { OUT (99h),A }
              $DB/$99/      { IN (99h),A  }
              $CB/$47/      { BIT 0,A     }
              $20/$F0/      { JR NZ, F0h  }
              $AF/          { XOR A       }
              $D3/$99/      { OUT (99h),A }
              $3E/$8F/      { LD A, 0fh   }
              $D3/$99      { OUT (99h),A }
			  /$FB              
            );
end;


function Inkey:char; 
var bt:integer;
    qqc:byte absolute $FCA9;
begin
     Inkey:=chr(0);
     qqc:=1;
     Inline($f3/$fd/$2a/$c0/$fc/$DD/$21/$9F/00     
            /$CD/$1c/00/$32/bt/$fb);
     Inkey:=chr(bt);
     qqc:=0;
end;

Procedure HideScreen;
begin
 inline($FD/$2A/$C1/$FC/$DD/$21/$41/$00/$CD/$1C/$00);
end;

Procedure ShowScreen;
begin
   INLINE ($fd/$2a/$c1/$fc/$dd/$21/$44/$00/$cd/$1c/$00);
end;


Procedure CopyF2(X1,Y1,W,DestX,DestY:integer);
var t:integer;
begin 
   if DestX<0 then begin
      W:=W+DestX;
      X1:=X1-DestX;
      DestX:=0;
   end else begin                
	  t:=DestX+W;
      if t>255 then W:=W-(t-256);
   end;         
   
   if W>0 then begin
   _sy := 256 + y1 ;
   _dy := Desty ;
   _dx := Destx;
   _sx := x1;            
   _nx := W;
   
   
       Inline (
              $3E/$20/  	{ LD A, 20h   } 
              $D3/$99/      { OUT (99h),A }
              $3E/$91/      { LD A, 11h   }
              $D3/$99/      { OUT (99h),A }
              $0E/$9B/      { LD C, 9Bh   } 
              $21/$62/$F5/  { LD HL,F562h }

              $ED/$A3/      { 15x OUTI, faster }
              $ED/$A3/      { than OTIR        }
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/

              $3E/$02/      { LD A, 02h   }
              $D3/$99/      { OUT (99h),A }
              
              $3E/$8F/      { LD A, 8fh   }
              
              $D3/$99/      { OUT (99h),A }
              $DB/$99/      { IN (99h),A  }
              $CB/$47/      { BIT 0,A     }
              $20/$F1/      { JR NZ, F0h  }
              $AF/          { XOR A       }
              $D3/$99/      { OUT (99h),A }
              $3E/$8F/      { LD A, 0fh   }
              $D3/$99       { OUT (99h),A }
              );
              (*

            );  *)  
	end;            
end;

Procedure CopyS(X1,Y1,DestX,DestY:integer);
begin
   _sy := 256 + y1;
   _dy := Desty ;
   _dx := Destx;
   _sx := x1;
       Inline (
              $3E/$20/  	{ LD A, 20h   } 
              $D3/$99/      { OUT (99h),A }
              $3E/$91/      { LD A, 11h   }
              $D3/$99/      { OUT (99h),A }
              $0E/$9B/      { LD C, 9Bh   } 
              $21/$62/$F5/  { LD HL,F562h }

              $ED/$A3/      { 15x OUTI, faster }
              $ED/$A3/      { than OTIR        }
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/
              $ED/$A3/

              $3E/$02/      { LD A, 02h   }
              $D3/$99/      { OUT (99h),A }
              
              $3E/$8F/      { LD A, 8fh   }
              $00/          {             }
              
              $D3/$99/      { OUT (99h),A }
              $DB/$99/      { IN (99h),A  }
              $CB/$47/      { BIT 0,A     }
              $20/$F0/      { JR NZ, F0h  }
              $AF/          { XOR A       }
              $D3/$99/      { OUT (99h),A }
              $3E/$8F/      { LD A, 0fh   }
              $D3/$99      { OUT (99h),A }
            );
end;

